version: 2
jobs:
  unit-test:
    docker:
      - image: circleci/golang:1.12
    steps:
      - checkout
      - run:
          name: Run unit test
          command:  go test -v -cover ./...
          environment:
            DB_NAME: "message"
            DB_HOST: "127.0.0.1:27017"
            SPARKPOST_API_KEY: "145774eee80ae462bf0f8ea6a7eb06c3b0183e94"
            DOMAIN: "https://staging-api.rewards.nexlife.com.my/"
            EMAIL_DOMAIN: "@nexlife.com.my"
            EMAIL_SENDER: "donotreply@nexlife.com.my"
            BCRYPT_COSR: "10"
            NUM_OF_STAMPS_PER_CARD: "5"
            ROOM_UPLOAD_DIR: "public/rooms"
            ENV: "prod"
            PORT_NUMBER: "80"
      - run:
          name: Submit code coverage report to codecov
          command:  echo "Submitting to codecov"
  build:
    docker:
      - image: docker:stable-git
    working_directory: /root/project
    environment:
      SERVICE_NAME: "chopchop-backend"        
    steps:
      - checkout
      - setup_remote_docker:
          docker_layer_caching: true
      - run:
          name: Copy SSH key
          command: cp /root/.ssh/id_rsa /root/project/
      - run:
          name: Build image
          command: docker build -t nexlife/chopchop-backend:backend .
      - run:
          name: save docker image
          command: docker save nexlife/chopchop-backend:backend > backend.tar 
  functional-test:
    docker:
      - image: docker:stable-git
    steps:
      - run:
          name: Run API functional testing
          command: echo "functional test"
workflows:
  version: 2
  build-deploy:
    jobs:
      - unit-test
      - build:
          requires:
            - unit-test
      - functional-test:
          requires:
            - build
          filters:
            branches:
              only:
                - master
                - staging
                - stable
